﻿//########################
//IllustratorCS3でトンボにトンボを付けます。
//トンボが着いていてもトンボの領域外にオブジェクトがあると
//そのオブジェクトのせいでセンターがずれる時があります。
//このスクリプトははみ出したオブジェクトを含めても
//トンボがセンターになるようにトンボを付けます。
//2010/05/07ガイドラインに反応しないようにしました。
//########################

var myAns = new Array();
var myPt = 1;
var lineW=0.05;
main();
function main(){
	if (app.documents.length == 0){
		alert("ドキュメントを開いてください");
		return;
	}
	if (app.selection.length == 0){
		alert("オブジェクトを選択してください");
		return;
	}
	var myRU = app.activeDocument.rulerUnits;
	if(myRU == RulerUnits.Centimeters){myPt = 28.3466796875;}
	else if(myRU == RulerUnits.Millimeters){myPt = 2.83466796875;}
	//選択された（トンボの）領域を調べる
	var selbounds = getselectedbounds(app.selection,null);
	//全ての領域を調べる
	var selboundsall = getselectedbounds(app.activeDocument.pageItems,selbounds);
	//左のオブジェクトのトンボとの距離
	var sa_width_l = selbounds[0]-selboundsall[0];
	//右のオブジェクトのトンボとの距離
	var sa_width_r = selboundsall[2]-selbounds[2];
	//上のオブジェクトのトンボとの距離
	var sa_Height_t = selboundsall[1]-selbounds[1];
	//下のオブジェクトのトンボとの距離
	var sa_Height_b = selbounds[3]-selboundsall[3];
	//ヨコの距離大きい方を採用
	if(sa_width_l > sa_width_r){
		var sa_width = sa_width_l;
	}else{
		var sa_width = sa_width_r;		
	}
	//タテの距離大きい方を採用
	if(sa_Height_t > sa_Height_b){
		var sa_Height = sa_Height_t;
	}else{
		var sa_Height = sa_Height_b;		
	}


	//var myBounds = new array(3);
	var myBounds = new Array(selbounds[0]-sa_width,selbounds[1]+sa_Height,selbounds[2]+sa_width,selbounds[3]-sa_Height);
	var X =myBounds[0]/myPt;//selAry[0].left/myPt;
	var Y =myBounds[1]/myPt;//selAry[0].top/myPt;
	var X2=myBounds[2]/myPt;//selAry[0].width/myPt;
	var Y2=myBounds[3]/myPt;//selAry[0].height/myPt;
	var W = X2 - X;
	var H = Y - Y2;
	var mygroup = activeDocument.groupItems.add();
	mygroup.name = "tombo";
	//左上
	drowCornerLine(X,Y,"LEFT","TOP",lineW,myPt,mygroup);
	//上センター
	drowLine(X+W/2,X+W/2,Y+13,Y+3,lineW,myPt,mygroup);
	drowLine(X+W/2-5,X+W/2+5,Y+7,Y+7,lineW,myPt,mygroup);
	drowEllipse(X+W/2-2,Y+7+2,4,4,lineW,myPt,mygroup);
	//右上
	drowCornerLine(X2,Y,"RIGHT","TOP",lineW,myPt,mygroup);
	//左センター
	drowLine(X-13,X-3,Y-H/2,Y-H/2,lineW,myPt,mygroup);
	drowLine(X-7,X-7,Y-H/2+5,Y-H/2-5,lineW,myPt,mygroup);
	drowEllipse(X-7-2,Y-H/2+2,4,4,lineW,myPt,mygroup);
	//右センター
	drowLine(X+W+3,X+W+13,Y-H/2,Y-H/2,lineW,myPt,mygroup);
	drowLine(X+W+7,X+W+7,Y-H/2+5,Y-H/2-5,lineW,myPt,mygroup);
	drowEllipse(X+W+7-2,Y-H/2+2,4,4,lineW,myPt,mygroup);
	//左下
	drowCornerLine(X,Y2,"LEFT","BOTTOM",lineW,myPt,mygroup);
	//下センター
	drowLine(X+W/2,X+W/2,Y-H-13,Y-H-3,lineW,myPt,mygroup);
	drowLine(X+W/2-5,X+W/2+5,Y-H-7,Y-H-7,lineW,myPt,mygroup);
	drowEllipse(X+W/2-2,Y-H-7+2,4,4,lineW,myPt,mygroup);
	//右下
	drowCornerLine(X2,Y2,"RIGHT","BOTTOM",lineW,myPt,mygroup);
}

function getselectedbounds(motoobj,selbounds){
	if(selbounds == null){
		var moto_bounds = motoobj[0].geometricBounds;
		var orgx2 = moto_bounds[0];
		var orgy2 = moto_bounds[1];
		var orgx1 = moto_bounds[2] ;
		var orgy1 = moto_bounds[3] ;
	}else{
		var orgx2 = selbounds[0];
		var orgy2 = selbounds[1];
		var orgx1 = selbounds[2] ;
		var orgy1 = selbounds[3] ;
	}
	for(var N = 0; N < motoobj.length;N++){
		if(motoobj[N].guides != true){
			var moto_bounds = motoobj[N].geometricBounds;
			var newx1_pos = moto_bounds[0] ;
			var newy1_pos = moto_bounds[1] ;
			var newx2_pos = moto_bounds[2] ;
			var newy2_pos = moto_bounds[3] ;
			if(newx1_pos < orgx1){orgx1 = newx1_pos;}
			if(newy1_pos > orgy1){orgy1 = newy1_pos;}
			if(newx2_pos > orgx2){orgx2 = newx2_pos;}
			if(newy2_pos < orgy2){orgy2 = newy2_pos;}
		}
	}
	return Array(orgx1,orgy1,orgx2,orgy2);
}





function drowCornerLine(X,Y,Xsel,Ysel,lineW,myPt,mygroup){
	if(Xsel == "LEFT"){
		var X1a = X - 13;
		var X2a = X - 3;
	}else{
		var X1a = X + 13;
		var X2a = X + 3;
	}
	if(Ysel == "TOP"){
		var Y1 = Y + 13;
		var Y2 = Y + 3;
	}else{
		var Y1 = Y - 13;
		var Y2 = Y - 3;
	}
	drowLine(X1a,X2a,Y,Y,lineW,myPt,mygroup);
	drowLine(X1a,X,Y2,Y2,lineW,myPt,mygroup);
	drowLine(X2a ,X2a ,Y1,Y,lineW,myPt,mygroup);
	drowLine(X,X,Y1,Y2,lineW,myPt,mygroup);
}

function reColor(C,M,Y,K){
	var myCMYK=new CMYKColor();
	//var myColor=new Color();
	
	myCMYK.cyan=C;
	myCMYK.magenta=M;
	myCMYK.yellow=Y;
	myCMYK.black=K;
	
	//myColor.cmyk=myCMYK;
	return myCMYK;
}

function drowLine(X1,X2,Y1,Y2,lineW,myPt,mygroup){
	tomboColor=reColor(100,100,100,100);
	myLine=mygroup.pathItems.add();
	myLine.setEntirePath([[X1*myPt,Y1*myPt],[X2*myPt,Y2*myPt]])
	myLine.filled=false;
	myLine.stroked=true;
	myLine.strokeWidth=lineW*myPt;
	myLine.strokeColor=tomboColor;
}

function drowEllipse(X,Y,W,H,lineW,myPt,mygroup){
	tomboColor=reColor(100,100,100,100);
	myObj=mygroup.pathItems.ellipse(Y*myPt,X*myPt,W*myPt,H*myPt);
	myObj.filled=false;
	myObj.stroked=true;
	myObj.strokeWidth=lineW*myPt;
	myObj.strokeColor=tomboColor;
}